diff --git a/src/main/java/net/minecraft/client/gui/GuiSleepMP.java b/src/main/java/net/minecraft/client/gui/GuiSleepMP.java
index 4b4004fcb..8f23abf8f 100644
--- a/src/main/java/net/minecraft/client/gui/GuiSleepMP.java
+++ b/src/main/java/net/minecraft/client/gui/GuiSleepMP.java
@@ -1,16 +1,16 @@
 package net.minecraft.client.gui;
 
-import net.minecraft.client.entity.player.EntityClientPlayerMP;
-import net.minecraft.client.net.handler.NetClientHandler;
-import net.minecraft.core.net.packet.Packet19EntityAction;
+import net.minecraft.client.entity.player.MultiplayerLocalPlayer;
+import net.minecraft.client.net.handler.ClientPacketHandler;
+import net.minecraft.core.net.packet.PlayerCommandPacket;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.net.ChatEmotes;
 import net.minecraft.core.lang.I18n;
 import org.lwjgl.input.Keyboard;
 
 // Referenced classes of package net.minecraft.src:
-//            GuiChat, StringTranslate, GuiButton, EntityPlayerSP, 
-//            EntityClientPlayerMP, Packet19EntityAction, NetClientHandler
+//            GuiChat, StringTranslate, GuiButton, LocalPlayer,
+//            MultiplayerLocalPlayer, PlayerCommandPacket, ClientPacketHandler
 
 public class GuiSleepMP extends GuiChat
 {
@@ -64,10 +64,10 @@ public class GuiSleepMP extends GuiChat
 
     private void func_22115_j()
     {
-        if(mc.thePlayer instanceof EntityClientPlayerMP)
+        if(mc.thePlayer instanceof MultiplayerLocalPlayer)
         {
-            NetClientHandler netclienthandler = ((EntityClientPlayerMP)mc.thePlayer).sendQueue;
-            netclienthandler.addToSendQueue(new Packet19EntityAction(mc.thePlayer, 3));
+            ClientPacketHandler netclienthandler = ((MultiplayerLocalPlayer)mc.thePlayer).sendQueue;
+            netclienthandler.addToSendQueue(new PlayerCommandPacket(mc.thePlayer, 3));
         }
     }
 }
diff --git a/src/main/java/net/minecraft/client/gui/GuiSlider.java b/src/main/java/net/minecraft/client/gui/GuiSlider.java
index 1d1fe3308..f449b25f7 100644
--- a/src/main/java/net/minecraft/client/gui/GuiSlider.java
+++ b/src/main/java/net/minecraft/client/gui/GuiSlider.java
@@ -1,6 +1,7 @@
 package net.minecraft.client.gui;
 
 import net.minecraft.client.render.FontRenderer;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import org.lwjgl.opengl.GL11;
 
 import net.minecraft.client.Minecraft;
@@ -58,16 +59,26 @@ public class GuiSlider extends GuiButton {
 		boolean mouseOver = mouseX >= xPosition && mouseY >= yPosition && mouseX < xPosition + width && mouseY < yPosition + height;
 		int state = getButtonState(mouseOver);
 
-		GL11.glBindTexture(GL11.GL_TEXTURE_2D, mc.renderEngine.getTexture("/assets/minecraft/textures/gui/gui.png"));
 		GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
 
+		IconCoordinate tex;
+		switch (state) {
+			case STATE_DISABLED:
+				tex = disabledTexture;
+				break;
+			case STATE_HOVERED:
+				tex = hoveredTexture;
+				break;
+			case STATE_DEFAULT:
+			default:
+				tex = defaultTexture;
+		}
+
 		// Draw background
-		drawTexturedModalRect(xPosition, yPosition, 0, 46, width / 2, height);
-		drawTexturedModalRect(xPosition + width / 2, yPosition, 200 - width / 2, 46, width / 2, height);
+		drawGuiIcon(xPosition, yPosition, width, height, disabledTexture);
 
 		// Draw foreground
-		drawTexturedModalRect(xPosition + (int) (sliderValue * (float) (width - 8)), yPosition, 0, 46 + state * 20, 4, 20);
-		drawTexturedModalRect(xPosition + (int) (sliderValue * (float) (width - 8)) + 4, yPosition, 196, 46 + state * 20, 4, 20);
+		drawGuiIcon(xPosition + (int) (sliderValue * (float) (width - 8)), yPosition, 8, height, tex);
 
 		mouseDragged(mc, mouseX, mouseY);
 
diff --git a/src/main/java/net/minecraft/client/gui/GuiSliderInteger.java b/src/main/java/net/minecraft/client/gui/GuiSliderInteger.java
index 15796b184..c6d4ca21c 100644
--- a/src/main/java/net/minecraft/client/gui/GuiSliderInteger.java
+++ b/src/main/java/net/minecraft/client/gui/GuiSliderInteger.java
@@ -1,6 +1,7 @@
 package net.minecraft.client.gui;
 
 import net.minecraft.client.render.FontRenderer;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import org.lwjgl.opengl.GL11;
 
 import net.minecraft.client.Minecraft;
@@ -59,18 +60,36 @@ public class GuiSliderInteger extends GuiButton {
 		boolean mouseOver = mouseX >= xPosition && mouseY >= yPosition && mouseX < xPosition + width && mouseY < yPosition + height;
 		int state = getButtonState(mouseOver);
 
-		GL11.glBindTexture(GL11.GL_TEXTURE_2D, mc.renderEngine.getTexture("/assets/minecraft/textures/gui/gui.png"));
 		GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
 
+		IconCoordinate tex;
+		switch (state) {
+			case STATE_DISABLED:
+				tex = disabledTexture;
+				break;
+			case STATE_HOVERED:
+				tex = hoveredTexture;
+				break;
+			case STATE_DEFAULT:
+			default:
+				tex = defaultTexture;
+		}
+
 		// Draw background
-		drawTexturedModalRect(xPosition, yPosition, 0, 46, width / 2, height);
-		drawTexturedModalRect(xPosition + width / 2, yPosition, 200 - width / 2, 46, width / 2, height);
+//		drawTexturedModalRect(xPosition, yPosition, 0, 46, width / 2, height);
+//		drawTexturedModalRect(xPosition + width / 2, yPosition, 200 - width / 2, 46, width / 2, height);
 
 		// Draw foreground
 		int sliderWidth = getSliderWidth();
 		int maxValue = option.size() - 1;
-		drawTexturedModalRect(xPosition + (int) ((sliderValue / (float) maxValue) * (float) (width - sliderWidth)), yPosition, 0, 46 + state * 20, sliderWidth / 2, 20);
-		drawTexturedModalRect(xPosition + (int) ((sliderValue / (float) maxValue) * (float) (width - sliderWidth)) + sliderWidth / 2, yPosition, 200 - sliderWidth / 2, 46 + state * 20, sliderWidth / 2, 20);
+//		drawTexturedModalRect(xPosition + (int) ((sliderValue / (float) maxValue) * (float) (width - sliderWidth)), yPosition, 0, 46 + state * 20, sliderWidth / 2, 20);
+//		drawTexturedModalRect(xPosition + (int) ((sliderValue / (float) maxValue) * (float) (width - sliderWidth)) + sliderWidth / 2, yPosition, 200 - sliderWidth / 2, 46 + state * 20, sliderWidth / 2, 20);
+
+		// Draw background
+		drawGuiIcon(xPosition, yPosition, width, height, disabledTexture);
+
+		// Draw foreground
+		drawGuiIcon(xPosition + (int) ((sliderValue / (float) maxValue) * (float) (width - sliderWidth)), yPosition, sliderWidth, height, tex);
 
 		mouseDragged(mc, mouseX, mouseY);
 
diff --git a/src/main/java/net/minecraft/client/gui/GuiSoundTest.java b/src/main/java/net/minecraft/client/gui/GuiSoundTest.java
new file mode 100644
index 000000000..24b5de7b2
--- /dev/null
+++ b/src/main/java/net/minecraft/client/gui/GuiSoundTest.java
@@ -0,0 +1,285 @@
+package net.minecraft.client.gui;
+
+import net.minecraft.client.Minecraft;
+import net.minecraft.client.gui.modelviewer.elements.GuiListenerButton;
+import net.minecraft.client.gui.modelviewer.elements.GuiListenerTextField;
+import net.minecraft.client.gui.modelviewer.elements.IListenerElement;
+import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.sound.SoundEngine;
+import net.minecraft.client.sound.SoundEntry;
+import net.minecraft.client.sound.SoundRepository;
+import net.minecraft.core.lang.I18n;
+import net.minecraft.core.sound.SoundCategory;
+import net.minecraft.core.util.helper.Utils;
+import org.jetbrains.annotations.Nullable;
+import org.lwjgl.input.Keyboard;
+import org.lwjgl.opengl.GL11;
+import paulscode.sound.SoundSystem;
+
+import java.io.File;
+import java.lang.reflect.Field;
+import java.util.ArrayList;
+import java.util.List;
+
+public class GuiSoundTest extends GuiScreen{
+    private static final int TOP_SPACING = 24;
+    private static final int BUTTON_SPACING = 4;
+
+    protected int top;
+    protected int bottom;
+
+    protected Field[] repoFields;
+    protected SoundRepository[] repos;
+
+    protected int repoIndex;
+    protected SoundRepository currentRepo;
+    protected int entryIndex = 0;
+    @Nullable
+    protected SoundEntry currentEntry;
+
+    protected GuiListenerButton leftEntry;
+    protected GuiListenerButton leftRepo;
+
+    protected float volume = 1;
+    protected float pitch = 1;
+
+    protected boolean showURL = true;
+
+    public GuiSoundTest(GuiScreen parent) {
+        super(parent);
+        initRepos();
+    }
+
+    public void initRepos(){
+        List<Field> fields = new ArrayList<>();
+        for (Field f : SoundEngine.class.getFields()){
+            if (f.getType().isAssignableFrom(SoundRepository.class)){
+                fields.add(f);
+            }
+        }
+        repoFields = new Field[fields.size()];
+        repos = new SoundRepository[fields.size()];
+        for (int i = 0; i < fields.size(); i++) {
+            repoFields[i] = fields.get(i);
+            try {
+                repos[i] = (SoundRepository) fields.get(i).get(Minecraft.getMinecraft(this).sndManager);
+            } catch (IllegalAccessException e) {
+                throw new RuntimeException(e);
+            }
+        }
+
+        currentRepo = repos[0];
+        currentEntry = currentRepo.getAllEntries().get(0);
+        entryIndex = 0;
+    }
+    @Override
+    public void keyTyped(char c, int key, int mouseX, int mouseY)
+    {
+        if (key == Keyboard.KEY_ESCAPE) {
+            mc.displayGuiScreen(parentScreen);
+        }
+        List<GuiButton> _buttons = new ArrayList<>(controlList);
+        for (GuiButton button : _buttons){
+            if (button instanceof IListenerElement && button.isHovered(mouseX, mouseY)){
+                ((IListenerElement) button).onKeyTyped(c, key);
+            }
+        }
+    }
+    @Override
+    public void tick(){
+        List<GuiButton> _buttons = new ArrayList<>(controlList);
+        for (GuiButton button : _buttons){
+            if (button instanceof GuiListenerButton){
+                ((GuiListenerButton) button).tick();
+            }
+        }
+    }
+    public void init()
+    {
+
+        top = TOP_SPACING;
+        bottom = height - (BUTTON_SPACING + 20 + BUTTON_SPACING);
+        add(new GuiListenerButton(0, width/2 - 100, height - (BUTTON_SPACING + 20), 200, 20, I18n.getInstance().translateKey("gui.sound_test.button.done")).setActionListener(() -> {
+            onClosed();
+            mc.displayGuiScreen(null);
+        }));
+
+        leftRepo = add(new GuiListenerButton(1, width - (20 + BUTTON_SPACING) * 2, bottom - (BUTTON_SPACING + 20), 20, 20, "<")
+            .setActionListener(() -> cycleRepo(-1)));
+        add(new GuiListenerButton(2, width - (20 + BUTTON_SPACING) * 1, bottom - (BUTTON_SPACING + 20), 20, 20, ">")
+            .setActionListener(() -> cycleRepo(1)));
+
+        leftEntry = add(new GuiListenerButton(11, width - (20 + BUTTON_SPACING) * 2, bottom - (BUTTON_SPACING + 20) * 2, 20, 20, "<")
+            .setActionListener(() -> cycleEntry(-1)));
+        add(new GuiListenerButton(12, width - (20 + BUTTON_SPACING) * 1, bottom - (BUTTON_SPACING + 20) * 2, 20, 20, ">")
+            .setActionListener(() -> cycleEntry(1)));
+
+        add(new GuiListenerButton(20, width/2 - 100, bottom - (BUTTON_SPACING + 20), 100 - BUTTON_SPACING/2, 20, I18n.getInstance().translateKey("gui.sound_test.button.play"))
+            .setActionListener(() -> playEntry(false))
+        );
+        add(new GuiListenerButton(21, width/2 + 100 - (100 - BUTTON_SPACING/2), bottom - (BUTTON_SPACING + 20), 100 - BUTTON_SPACING/2, 20, I18n.getInstance().translateKey("gui.sound_test.button.play_stream"))
+            .setActionListener(() -> playEntry(true))
+        );
+        add(new GuiListenerButton(22, width/2 + 100 + BUTTON_SPACING, bottom - (BUTTON_SPACING + 20), 20, 20, "X")
+            .setActionListener(this::stopSound)
+        );
+
+
+        add(new GuiListenerButton(30, BUTTON_SPACING, bottom - (BUTTON_SPACING + 20), 20, 20, "")
+            .setActionListener(() -> Utils.openDirectory(new File(mc.getMinecraftDir(), "resources")))
+            .setTextures("minecraft:gui/misc/button_folder", "minecraft:gui/misc/button_folder_highlighted", "minecraft:gui/misc/button_folder"));
+
+        add(new GuiListenerButton(31, 20 + BUTTON_SPACING * 2, bottom - (BUTTON_SPACING + 20), 20, 20, "V"))
+            .setActionListener(() -> showURL = !showURL);
+
+        add(new GuiListenerButton(32, 40 + BUTTON_SPACING * 3, bottom - (BUTTON_SPACING + 20), 40, 20, I18n.getInstance().translateKey("gui.sound_test.button.reload")))
+            .setActionListener(() -> {
+                mc.sndManager = new SoundEngine();
+                mc.sndManager.init(mc.gameSettings);
+                mc.downloadResourcesThread.reloadResources();
+                initRepos();
+            });
+
+        GuiListenerTextField volumeField = new GuiListenerTextField(parentScreen, mc.fontRenderer, width - BUTTON_SPACING - 60, bottom - (BUTTON_SPACING + 20) * 3, 60, 20, String.valueOf(volume), "Volume");
+        add(volumeField)
+            .setPrefaceText("Vol: ")
+            .setKeyListener(key -> {
+                try {
+                    volume = Float.parseFloat(volumeField.getText());
+                } catch (Exception ignored){}})
+            .setActionListener(() -> {
+                if (Keyboard.isKeyDown(Keyboard.KEY_LCONTROL)){
+                    volumeField.setText(String.valueOf(1));
+                    volume = 1;
+                }});
+
+        GuiListenerTextField pitchField = new GuiListenerTextField(parentScreen, mc.fontRenderer, width - BUTTON_SPACING - 60, bottom - (BUTTON_SPACING + 20) * 4, 60, 20, String.valueOf(pitch), "Pitch");
+        add(pitchField)
+            .setPrefaceText("Pitch: ")
+            .setKeyListener(key -> {
+                try {
+                    pitch = Float.parseFloat(pitchField.getText());
+                } catch (Exception ignored){}})
+            .setActionListener(() -> {
+                if (Keyboard.isKeyDown(Keyboard.KEY_LCONTROL)){
+                    pitchField.setText(String.valueOf(1));
+                    pitch = 1;
+                }});
+    }
+
+    protected void buttonPressed(GuiButton button)
+    {
+    }
+
+    protected void buttonReleased(GuiButton button)
+    {
+    }
+
+    protected void cycleRepo(int offset) {
+        int index = (repoIndex + offset + repos.length) % repos.length;
+        currentRepo = repos[index];
+        repoIndex = index;
+        try {
+            currentEntry = currentRepo.getAllEntries().get(0);
+            entryIndex = 0;
+        } catch (Exception e) {
+            currentEntry = null;
+            entryIndex = -1;
+        }
+    }
+
+    protected void cycleEntry(int offset) {
+        if (currentRepo.getAllEntries().size() <= 0) return;
+        int index = (entryIndex + offset + currentRepo.getAllEntries().size()) % currentRepo.getAllEntries().size();
+        currentEntry = currentRepo.getAllEntries().get(index);
+        entryIndex = index;
+    }
+
+    public void drawScreen(int mouseX, int mouseY, float partialTick) {
+        drawDefaultBackground();
+
+        super.drawScreen(mouseX, mouseY, partialTick);
+
+        fontRenderer.drawCenteredString(I18n.getInstance().translateKey("gui.sound_test.label.title"), width/2, 5, 0xFFFFFF);
+
+        fontRenderer.drawCenteredString(I18n.getInstance().translateKeyAndFormat("gui.sound_test.label.repo", repoFields[repoIndex].getName()), width/2, top + 10, 0xFFFFFF);
+
+        String msg = I18n.getInstance().translateKey("gui.sound_test.label.select_repo");
+        fontRenderer.drawString(msg, leftRepo.getX() - BUTTON_SPACING - fontRenderer.getStringWidth(msg), leftRepo.getY() + 6, 0xFFFFFF);
+        msg = I18n.getInstance().translateKey("gui.sound_test.label.select_entry");
+        fontRenderer.drawString(msg, leftEntry.getX() - BUTTON_SPACING - fontRenderer.getStringWidth(msg), leftEntry.getY() + 6, 0xFFFFFF);
+
+        StringBuilder builder = new StringBuilder();
+        builder.append(fontRenderer.wrapFormattedStringToWidth(I18n.getInstance().translateKeyAndFormat("gui.sound_test.label.id", currentEntry == null ? null : currentEntry.soundID), width - 10)).append("\n");
+        builder.append(fontRenderer.wrapFormattedStringToWidth(I18n.getInstance().translateKeyAndFormat("gui.sound_test.label.name", currentEntry == null ? null : currentEntry.name), width - 10)).append("\n");
+        builder.append(fontRenderer.wrapFormattedStringToWidth(I18n.getInstance().translateKeyAndFormat("gui.sound_test.label.url", String.valueOf(currentEntry == null ? null : (showURL ? currentEntry.url : "REDACTED"))), width - 10)).append("\n");
+        String[] lines = builder.toString().split("\n");
+        int y = top + 30;
+        for (String line : lines) {
+            fontRenderer.drawString(line, 5, y, 0xBBBBBB);
+            y += 10;
+        }
+    }
+    @Override
+    public void drawDefaultBackground() {
+        super.drawDefaultBackground();
+
+        if (mc.theWorld == null)
+        {
+            Tessellator tessellator = Tessellator.instance;
+            mc.renderEngine.loadTexture("/assets/minecraft/textures/gui/background.png").bind();
+            GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
+            float scale = 32F;
+            tessellator.startDrawingQuads();
+            tessellator.setColorOpaque_I(0x202020);
+
+            tessellator.addVertexWithUV(0,      bottom, 0.0D,   0,              bottom / scale);
+            tessellator.addVertexWithUV(width,  bottom, 0.0D,   width / scale,  bottom / scale);
+            tessellator.addVertexWithUV(width,  top,    0.0D,   width / scale,  top / scale);
+            tessellator.addVertexWithUV(0,      top,    0.0D,   0,              top / scale);
+
+            tessellator.draw();
+        }
+        else
+        {
+            drawRect(0, 0, width, top, 0x5F000000);
+            drawRect(0, bottom, width, height, 0x5F000000);
+        }
+    }
+
+    public void playEntry(boolean asStream) {
+        if (currentEntry == null) return;
+        if (asStream) {
+            final float streamingVolume = 16F;
+            SoundSystem soundSystem = SoundEngine.getSoundSystem();
+            soundSystem.newStreamingSource(true, "debug", currentEntry.url, currentEntry.name, false, 0, 0, 0, 2, streamingVolume * 4F);
+            soundSystem.setVolume("debug", volume * mc.gameSettings.masterVolume.value);
+            soundSystem.play("debug");
+        } else  {
+            mc.sndManager.playSoundEntry(currentEntry, "debug", SoundCategory.GUI_SOUNDS, volume, pitch);
+        }
+    }
+
+    public void stopSound() {
+        SoundEngine.getSoundSystem().stop("debug");
+    }
+
+    private void overlayBackground(int minX, int maxX, int minY, int maxY)
+    {
+        if (mc.theWorld == null)
+        {
+            Tessellator tessellator = Tessellator.instance;
+            mc.renderEngine.loadTexture("/assets/minecraft/textures/gui/background.png").bind();
+            GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
+            float scale = 32F;
+            tessellator.startDrawingQuads();
+            tessellator.setColorOpaque_I(0x404040);
+            tessellator.addVertexWithUV(minX, maxY, 0.0D, (float) minX / scale, (float) maxY / scale);
+            tessellator.addVertexWithUV(maxX, maxY, 0.0D, (float) maxX / scale, (float) maxY / scale);
+            tessellator.setColorOpaque_I(0x404040);
+            tessellator.addVertexWithUV(maxX, minY, 0.0D, (float) maxX / scale, (float) minY / scale);
+            tessellator.addVertexWithUV(minX, minY, 0.0D, (float) minX / scale, (float) minY / scale);
+            tessellator.draw();
+        }
+    }
+}
